<template>
    <div class="edit-popup">
        <popup
            ref="popupRef"
            :title="popupTitle"
            :async="true"
            width="550px"
            @confirm="handleSubmit"
            @close="handleClose"
        >
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="模型" prop="model">
                    <el-input v-model="formData.model" clearable placeholder="请输入模型" :readonly="false"/>
                </el-form-item>
                <el-form-item label="关联id" prop="link_id">
                    <el-input v-model="formData.link_id" clearable placeholder="请输入关联id" :readonly="false"/>
                </el-form-item>
                <el-form-item label="数量" prop="nums">
                    <el-input v-model="formData.nums" clearable placeholder="请输入数量" :readonly="false"/>
                </el-form-item>
                <el-form-item label="类型" prop="pm">
                    <el-select class="flex-1" v-model="formData.pm" clearable placeholder="请选择类型" :disabled="false">
                        <el-option 
                            v-for="(item, index) in dictData.business_status"
                            :key="index" 
                            :label="item.name"
                            :value="parseInt(item.value)"
                        />
                    </el-select>
                </el-form-item>
                <el-form-item label="请求" prop="url">
                    <el-input v-model="formData.url" clearable placeholder="请输入请求" :readonly="false"/>
                </el-form-item>
                <el-form-item label="备注" prop="mark">
                    <el-input v-model="formData.mark" clearable placeholder="请输入备注" :readonly="false"/>
                </el-form-item>

            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="changeLogEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiChangeLogAdd, apiChangeLogEdit, apiChangeLogDetail } from '@/api/change_log'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')


// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑数据变更记录' : '新增数据变更记录'
})

// 表单数据
const formData = reactive({
    id: '',
    model: '',
    link_id: '',
    nums: '',
    pm: '',
    url: '',
    mark: '',

})


// 表单验证
const formRules = reactive<any>({

})


// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }
    
    
}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiChangeLogDetail({
        id: row.id
    })
    setFormData(data)
}


// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData,  }
    mode.value == 'edit' 
        ? await apiChangeLogEdit(data) 
        : await apiChangeLogAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}



defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
